LinuxQuestions.org
Share your knowledge at the LQ Wiki.
Home Forums Tutorials Articles Register
Go Back   LinuxQuestions.org > Forums > Linux Forums > Linux - Distributions > Slackware
User Name
Password
Slackware This Forum is for the discussion of Slackware Linux.

Notices


Reply
  Search this Thread
Old 11-12-2010, 10:30 AM   #1
2handband
Member
 
Registered: Jan 2009
Location: Alexandria, Minnesota
Distribution: Manjaro
Posts: 837

Rep: Reputation: 96
How to make Konqueror a viable web browser


It's been a long time coming... I've finally got Konqueror working well enough to uninstall Firefox. The problem has been KHTML, which has big problems rendering modern web content with heavy scripting. Fortunately a team of developers has been working on creating a webkit rendering engine as a modular Kpart for Konqueror. Kwebkit will probably be included with KDE 4.6, but for the moment it's something you have to install yourself. Here's what I did.

First of all, these steps were all performed on a -current64 box with Alien Bob's KDE 4.5.3 package (http://alien.slackbook.org/ktown/4.5.3/) installed. I started out by installing kwebkitpart using the package available here: http://slackbuilds.org/repository/13...s/kwebkitpart/

At this point you can use kwebkit by launching Konqueror, going into View > View Mode and selecting Kwebkit. Trouble is, it's not going to be stable... Konqueror will crash constantly. In order to achieve stability you have to install QT4.7 or higher.

You can get the latest QT (4.7.1) here: http://qt.nokia.com/downloads/
You don't need the complete development environment; just get the framework. I'm assuming here that you have the Slackware source tree somewhere on your hard drive (mine is in /opt). You'll find QT in the /l directory. Save the existing source code somewhere else and put the code you just downloaded in it's place. Because the new source code has a different name you'll have to modify the script accordingly. I modified this line:

Code:
if [ -r $CWD/qt-$VERSION.tar.gz ]; then
  tar xvf $CWD/qt-$VERSION.tar.gz || exit 1
To:

Code:
if [ -r $CWD/qt-$VERSION-opensource-src-4.7.1.tar.gz ]; then
  tar xvf $CWD/qt-$VERSION-opensource-src-4.7.1.tar.gz || exit 1
And:

Code:
cd qt-$VERSION || exit 1
To:

Code:
cd qt-$VERSION-opensource-src-4.7.1 || exit 1
By the way, I dropped into init 1 before performing the build:

Code:
init 1
I'm not sure that's really necessary, but I like to do that before doing anything that directly affects the GUI. Anyway, I then just ran the Slackbuild:

Code:
./qt.Slackbuild
It took a long time. After it builds you can go into pkgtool and uninstall the previous version of qt. Then reboot your box. I rebooted into init 3 so I'd have a working terminal if something went wrong with the new version of qt. But no prob; I booted into the terminal, logged in, startx and no sweat.

You can now follow the procedure I outlined above to enable Kwebkit, but KHTML is still the default and will be reverted to every time you restart Konqueror, or even open a new tab! No good. You want to make Kwebkit the default.

Go back into your terminal (as your regular user) and enter the following:

Code:
keditfiletype text/html
Then in the resulting window click the Embedding tab and move WebKit to the top of the list. Hopefully they'll come up with a more user-friendly way to get into that menu for KDE 4.6.

Now restart Konqueror and voila! That should be it. I've been using it since yesterday and have had no issues with stability, and all the old rendering problems are gone (okay, there's still room for refinement, but it's 99% there). Better yet, performance is HUGELY improved (and Konqueror is faster than Firefox to begin with). So rendering is excellent, desktop integration is 100%, performance is superb... what more could you ask for?

Thanks to Grapefruitgirl for helping me get qt installed, and thanks to the kwebkit dev team for getting this together for us!

Last edited by 2handband; 11-12-2010 at 10:31 AM.
 
Old 11-12-2010, 11:03 AM   #2
cwizardone
LQ Veteran
 
Registered: Feb 2007
Distribution: Slackware64-current with "True Multilib" and KDE4Town.
Posts: 9,095

Rep: Reputation: 7272Reputation: 7272Reputation: 7272Reputation: 7272Reputation: 7272Reputation: 7272Reputation: 7272Reputation: 7272Reputation: 7272Reputation: 7272Reputation: 7272
Many Thanks!
 
Old 11-12-2010, 11:09 AM   #3
brixtoncalling
Member
 
Registered: Jul 2008
Location: British Columbia
Distribution: Slackware current
Posts: 403

Rep: Reputation: 67
To get something similar, you can also install reKonq (it's in the Slackbuilds repo). It's a lightweight Webkit browser for KDE -- and it integrates very well.
 
Old 11-12-2010, 11:23 AM   #4
2handband
Member
 
Registered: Jan 2009
Location: Alexandria, Minnesota
Distribution: Manjaro
Posts: 837

Original Poster
Rep: Reputation: 96
Rekonq is all right... but not configurable enough for me (and the lack of a google search bar is a showstopper).
 
Old 11-12-2010, 12:55 PM   #5
brixtoncalling
Member
 
Registered: Jul 2008
Location: British Columbia
Distribution: Slackware current
Posts: 403

Rep: Reputation: 67
Quote:
Originally Posted by 2handband View Post
Rekonq is all right... but not configurable enough for me (and the lack of a google search bar is a showstopper).
Yeah, I guess it is a matter of taste... I just use the gg: shortcut in Konqueror and reKonq and never touch the search bar.
 
Old 11-12-2010, 03:43 PM   #6
mlangdn
Senior Member
 
Registered: Mar 2005
Location: Kentucky
Distribution: Slackware64-current
Posts: 1,845

Rep: Reputation: 452Reputation: 452Reputation: 452Reputation: 452Reputation: 452
Interesting. I may give this a go just to see the difference!
 
Old 11-12-2010, 07:23 PM   #7
mlangdn
Senior Member
 
Registered: Mar 2005
Location: Kentucky
Distribution: Slackware64-current
Posts: 1,845

Rep: Reputation: 452Reputation: 452Reputation: 452Reputation: 452Reputation: 452
QT has been compiling for about 10 minutes. I think it will have about another hour yet. I'll probably be in the bed before then, which means I will finish this up tomorrow. I gotta be up at 3 am cst for work. I hate leaving a project half-finished.
 
Old 11-13-2010, 08:46 AM   #8
piratesmack
Member
 
Registered: Feb 2009
Distribution: Slackware, Arch
Posts: 519

Rep: Reputation: 142Reputation: 142
Thanks, building now

But I downloaded KDE's patched qt 4.7.0 instead
http://qt.gitorious.org/qt/kde-qt/ar.../4.7.0-patched

Renamed it to qt-4.7.0.tar.gz

And modified the SlackBuild like this:
Code:
--- qt.orig/qt.SlackBuild	2010-03-24 14:10:07.000000000 -0600
+++ qt/qt.SlackBuild	2010-11-13 06:26:21.752751852 -0700
@@ -74,7 +74,7 @@
 #tar xvf $CWD/qt-x11-opensource-src-$VERSION.tar.gz     # For qt releases
 #cd qt-x11-opensource-src-$VERSION || exit 1
 
-rm -rf qt-$VERSION
+rm -rf qt-kde-qt
 if [ -r $CWD/qt-$VERSION.tar.gz ]; then
   tar xvf $CWD/qt-$VERSION.tar.gz || exit 1
 elif [ -r $CWD/qt-$VERSION.tar.bz2 ]; then
@@ -86,7 +86,7 @@
 else
   exit 1
 fi
-cd qt-$VERSION || exit 1
+cd qt-kde-qt || exit 1
 
 chown -R root:root .
 find . \
Save as qt.SlackBuild.diff, and apply with:
Code:
patch -p1 -i qt.SlackBuild.diff
Hope this works out.
I'd really like to ditch Chrome for something KDE.

Last edited by piratesmack; 11-13-2010 at 09:00 AM.
 
Old 11-13-2010, 10:06 PM   #9
mlangdn
Senior Member
 
Registered: Mar 2005
Location: Kentucky
Distribution: Slackware64-current
Posts: 1,845

Rep: Reputation: 452Reputation: 452Reputation: 452Reputation: 452Reputation: 452
Wow! There is a very real difference in the way the pages render now between FF and Konqueror. Also, the layout is much different and seems to be clearer and sharper. It may just be my imagination - it will take more than a couple of pages to see. I think I will zip through all the bookmarks and see what it looks like.

So far, so good!
 
Old 11-14-2010, 02:24 AM   #10
JackHair
Member
 
Registered: Aug 2009
Location: Netherlands
Distribution: Slackware64-current
Posts: 167

Rep: Reputation: 39
Konquer works really well with kwebkit. But the back/forward mousebuttons don't work. This is a real showstopper for me
 
Old 11-14-2010, 06:08 AM   #11
2handband
Member
 
Registered: Jan 2009
Location: Alexandria, Minnesota
Distribution: Manjaro
Posts: 837

Original Poster
Rep: Reputation: 96
Quote:
Originally Posted by JackHair View Post
Konquer works really well with kwebkit. But the back/forward mousebuttons don't work. This is a real showstopper for me
I didn't know they made mice with back/forward buttons...
 
Old 11-15-2010, 03:36 AM   #12
JackHair
Member
 
Registered: Aug 2009
Location: Netherlands
Distribution: Slackware64-current
Posts: 167

Rep: Reputation: 39
Quote:
Originally Posted by 2handband View Post
I didn't know they made mice with back/forward buttons...
You never seen a mouse with thumb buttons? Which in EVERY other browser are used for back/forward by default? Guess you're living in a cave? Oh wait, you're just being a smart-ass, thanks!
 
Old 11-15-2010, 07:01 AM   #13
2handband
Member
 
Registered: Jan 2009
Location: Alexandria, Minnesota
Distribution: Manjaro
Posts: 837

Original Poster
Rep: Reputation: 96
Quote:
Originally Posted by JackHair View Post
You never seen a mouse with thumb buttons? Which in EVERY other browser are used for back/forward by default? Guess you're living in a cave? Oh wait, you're just being a smart-ass, thanks!
No, not being a smart-ass... I just always buy the cheapest optical mouse available when I need a new one, so I have no idea what all the extra buttons on the more expensive models do. If you like I'll put in a feature request for you... I'm fairly active on the KDE forums.
 
Old 11-15-2010, 07:58 AM   #14
mlangdn
Senior Member
 
Registered: Mar 2005
Location: Kentucky
Distribution: Slackware64-current
Posts: 1,845

Rep: Reputation: 452Reputation: 452Reputation: 452Reputation: 452Reputation: 452
I always buy the cheapest optical mouse myself. I don't think I've ever spent over $10 US for a mouse. I've never heard of back/forward buttons either. I have a scroll wheel that goes up and down. I reckon I live in a cave.
 
Old 11-15-2010, 09:03 AM   #15
mlangdn
Senior Member
 
Registered: Mar 2005
Location: Kentucky
Distribution: Slackware64-current
Posts: 1,845

Rep: Reputation: 452Reputation: 452Reputation: 452Reputation: 452Reputation: 452
So much for Konqueror after the updates of -current. It crashes constantly. I did not upgrade qt from the one I built a couple of days ago. I copied the last few lines from the cli after starting konqueror:

Code:
konqueror(8284)/kio (KIOJob) KIO::TransferJob::slotMimetype: mimetype() emitted again, or after sending first data!; job URL = KUrl("http://static.chartbeat.com/js/chartbeat.js") 
konqueror(8284)/kdecore (KLibrary) kde4Factory: The library "/usr/lib64/kde4/kwebkitpart.so" does not offer a qt_plugin_instance function.
Segmentation fault
michael@BlackWizard:~$
I'll visit this later.
 
  


Reply



Posting Rules
You may not post new threads
You may not post replies
You may not post attachments
You may not edit your posts

BB code is On
Smilies are On
[IMG] code is Off
HTML code is Off



Similar Threads
Thread Thread Starter Forum Replies Last Post
Konqueror Web Browser dudeman41465 Linux - Software 16 02-22-2022 12:46 PM
Konqueror Web Browser PS1 Linux - Newbie 1 03-23-2006 11:03 AM
browser plugin for Konqueror web browser (linspire) Tracianddwayne Linux - Newbie 1 01-01-2005 02:15 PM
please tell how to make a plugin for a web-browser (konqueror) using c++ / Qt / Java gajaykrishnan Programming 1 07-22-2004 11:28 AM
Konqueror Web Browser - help! JonnyL Linux - Newbie 4 02-26-2003 03:47 PM

LinuxQuestions.org > Forums > Linux Forums > Linux - Distributions > Slackware

All times are GMT -5. The time now is 05:51 AM.

Main Menu
Advertisement
My LQ
Write for LQ
LinuxQuestions.org is looking for people interested in writing Editorials, Articles, Reviews, and more. If you'd like to contribute content, let us know.
Main Menu
Syndicate
RSS1  Latest Threads
RSS1  LQ News
Twitter: @linuxquestions
Open Source Consulting | Domain Registration